#!/bin/bash

#SBATCH --nodes=1
#SBATCH --gres=gpu:v100l:4    #keep 1 for testing
#SBATCH --cpus-per-task=32   # maximum CPU cores per GPU request: 6 on Cedar, 16 on Graham.
#SBATCH --mem=0        # Request the full memory of the node # memory per node, 256000M
#SBATCH --account=def-XXXX-5
#SBATCH --time=0-22:00      # time (DD-HH:MM)
#SBATCH --output=CG2b_checkpoints_RLSF_MultiGPUv2/run-%N-%j.out  # %N for node name, %j for jobID

module load StdEnv/2020 gcc/9.3.0 cuda/11.4 python/3.10
module load arrow/13

source ~/rlsf/bin/activate

accelerate launch --config_file /home/XXXX-3/.cache/huggingface/accelerate/default_config.yaml CG2b_RLSF_main_multiGPU.py --batch_size 12 --output_dir ./CG2b_checkpoints_RLSF_MultiGPU > "CG2b_checkpoints_RLSF_MultiGPU/out.txt" 2>&1

echo "Evaluation end"