#!/bin/bash

#SBATCH --gres=gpu:v100l:1    #keep 1 for testing
#SBATCH --cpus-per-task=3   # maximum CPU cores per GPU request: 6 on Cedar, 16 on Graham.
#SBATCH --mem=32000M        # Request the full memory of the node # memory per node, 256000M
#SBATCH --account=def-XXXX-5
#SBATCH --time=0-3:00      # time (DD-HH:MM)
#SBATCH --output=./resultsFolder/RLSF_CodeGemma2b/run-%N-%j.out  # %N for node name, %j for jobID

module load StdEnv/2020 gcc/9.3.0 cuda/11.4 python/3.10
module load arrow/13

source ~/rlsf/bin/activate

accelerate launch --config_file /home/XXXX-3/.cache/huggingface/accelerate/default_config.yaml --num_processes 1 CG2b_RL_inference.py > "./resultsFolder/RLSF_CodeGemma2b/out.txt" 2>&1

echo "Evaluation end"