from tqdm import tqdm
from openai import OpenAI
import os, sys
import json
import jsonlines
os.environ["OPENAI_API_KEY"] = "XXXX"

def savePredictions(progList, indx):
    filePath = os.path.join("ChatGPT", "pred" + str(indx) + ".jsonl")
    predList = []
    for p in progList:
        predList.append({"predC++": p})
    with jsonlines.open(filePath, 'w') as writer:
        writer.write_all(predList)


with open('./dataset/pseudocode-cpp/test.pseudocode-cpp.jsonl', 'r') as json_file:
    json_list = list(json_file)

promptList = []

for json_str in json_list:
    result = json.loads(json_str)
    prompt = result["prompt"]
    promptList.append(prompt)

client = OpenAI()
translations = []

for promptIndx, prompt in tqdm(enumerate(promptList), total=len(promptList)):
    print (prompt)
    #"gpt-3.5-turbo-0301"
    messages = [{
            "role": "user",
            "content": prompt
          }]
    print (messages, flush = True)

    response = client.chat.completions.create(
      model = "gpt-3.5-turbo-0301",
      messages = messages,
      temperature = 0,
      max_tokens = 512,
      top_p = 0,
      frequency_penalty = 0,
      presence_penalty = 0
    )

    print ("tt----------tt", flush = True)
    translation = response.choices[0].message.content
    #translation = "junk" + str(promptIndx)
    print (translation, flush = True)
    print ("ll----------ll", flush = True)

    translations.append(translation)
    #if (oneLineProgIndx == 100):
    #  break
    if promptIndx % 100 == 0:
      savePredictions(translations, promptIndx)

savePredictions(translations, "")