import argparse
from tot.methods.bfs import solve
from tot.tasks.game24 import Game24Task

args = argparse.Namespace(backend='gemma-2b-it', temperature=0.3, task='game24', naive_run=False, prompt_sample=None, method_generate='propose', method_evaluate='value', method_select='greedy', n_generate_sample=1, n_evaluate_sample=3, n_select_sample=5)

task = Game24Task()
task.load_model(model=args.backend)
ys, infos = solve(args, task, 900)
print(ys[0])

# task.df_errors.to_csv(task.csv_filename, index=False)
# task.df_replacements.to_csv(task.csv_filename.replace('.csv', '_replacements.csv'), index=False)
task.prompt_df.to_csv(task.csv_filename.replace('.csv', f'_{args.backend}_prompt.csv'), index=False)

"""
n_generate_sample=1 -> only one propose prompt -> but this generates multiple (m) proposals
n_evaluate_sample=3 -> 3 value prompts for each proposal is summed up to get the value of the proposal
n_select_sample=5 -> top 5 proposals are selected for the next step (greedy selection). In later steps even though 5*m options are available, this will be clipped to 5
"""