import re
import os
import sympy
import pandas as pd

def solvercheck_propose_prompt_out(second_to_last_line_left, last_line, current_numbers): # error logs arranged in the order of precedence, but we will still log all of them
        assert "left: " in last_line, f"The last line does not have the 'left:' part: {last_line}"
        # check the current_numbers have correct numbers 
        last_line_correct = last_line # if everything is correct till the last return statement
        second_to_last_line = second_to_last_line_left
        try:
            second_to_last_line_numbers = re.findall(r'-?\d*\.\d+|-?\d+', second_to_last_line) # second_to_last_line example - '4 6 4 8'
            last_line_expr = last_line.split('(left: ')[0] # last_line_expr example - '4 + 8 = 12'
            last_line_expr_lhs_numbers = re.findall(r'-?\d*\.\d+|-?\d+', last_line_expr.split('=')[0]) # last_line_expr_lhs_numbers example - '4 8'
            last_line_expr_rhs_number = re.findall(r'-?\d*\.\d+|-?\d+', last_line_expr.split('=')[1])[0] # last_line_expr_rhs_number example - '12'
            last_line_left_numbers = re.findall(r'-?\d*\.\d+|-?\d+', current_numbers) # current_numbers example - '4 6 12'
        except Exception as e:
            print(e)
            return 'X'*len(last_line) # replacing with random -> will be used for error vector calculation only

        # second_to_last_line_numbers - last_line_expr_lhs_numbers + last_line_expr_rhs_number = last_line_left_numbers
        for number in last_line_expr_lhs_numbers:
            if number in second_to_last_line_numbers:
                second_to_last_line_numbers.remove(number)
            else:
                # self.df_errors = self.df_errors._append({'Category': 'PROPOSE', 'Sub-category': 'INCORRECT(E3)', 'Left': second_to_last_line, 'last_line': last_line, 'Reason': f'Invalid number {number} used in the expression'}, ignore_index=True) # e.g., 4 + 8 = 12, but 4 is not in the second_to_last_line_numbers
                # print(f'Invalid number {number} used in the expression')
                # if there is an invalid number, we don't need to check the rest of the conditions
                # also since it is only used for error vector calculation, just replacing with X works
                return last_line.replace(str(number)+' ', 'X'*len(str(number))+' ') 

        # now since valid numbers are present, we can check if the expression is correct
        try:
            if not sympy.simplify(last_line_expr.replace('=', '-')+' < 0.01'):
                # self.df_errors = self.df_errors._append({'Category': 'PROPOSE', 'Sub-category': 'INCORRECT(E4)', 'Left': second_to_last_line, 'last_line': last_line, 'Reason': f'Expression {last_line_expr.split("=")[0]} does not equal {last_line_expr_rhs_number}'}, ignore_index=True)
                cut_string = last_line.split('=')[1].split('left')[0].strip() # string between '=' and 'left' in y; keep ( intact so that it is easy to replace
                eval_res = eval(last_line_expr.split("=")[0])
                if eval_res == int(eval_res): eval_res = int(eval_res) # if the result is an integer, convert it to an integer (e.g., 12.0 to 12)
                last_line_correct = last_line.replace(cut_string, str(eval_res)+" (") # replace the incorrect rhs result with the correct one
                last_line = last_line_correct # update last_line to the corrected value for the next checks
        except Exception as e: 
            print(e)
            print("Ignoring the exception and continuing...") 
            return 'X'*len(last_line) # replacing with random -> will be used for error vector calculation only

        eval_res = eval(last_line_expr.split("=")[0])
        if eval_res == int(eval_res): eval_res = int(eval_res)
        ideal_rhs_number = str(eval_res)
        ideal_left_numbers = sorted(second_to_last_line_numbers + [ideal_rhs_number])
        if len(ideal_left_numbers) > len(last_line_left_numbers):
            missing_numbers = [number for number in ideal_left_numbers if number not in last_line_left_numbers]
            # self.df_errors = self.df_errors._append({'Category': 'PROPOSE', 'Sub-category': 'INCORRECT(E5)', 'Left': second_to_last_line, 'last_line': last_line, 'Reason': f'Numbers {missing_numbers} are missing in the last line'}, ignore_index=True)
            last_line_correct = last_line.replace('left: ' + current_numbers, 'left: ' + ' '.join(map(str, ideal_left_numbers))) # replace the incorrect left numbers with the correct ones
        elif len(ideal_left_numbers) < len(last_line_left_numbers):
            extra_numbers = [number for number in last_line_left_numbers if number not in ideal_left_numbers]
            # self.df_errors = self.df_errors._append({'Category': 'PROPOSE', 'Sub-category': 'INCORRECT(E6)', 'Left': second_to_last_line, 'last_line': last_line, 'Reason': f'Numbers {extra_numbers} are extra in the last line'}, ignore_index=True)
            last_line_correct = last_line.replace('left: ' + current_numbers, 'left: ' + ' '.join(map(str, ideal_left_numbers))) # replace the incorrect left numbers with the correct ones
        else: # len(ideal_left_numbers) == len(last_line_left_numbers)
            if sorted(ideal_left_numbers) != sorted(last_line_left_numbers):
                incorrect_numbers = [number for number in last_line_left_numbers if number not in ideal_left_numbers]
                expected_numbers = [number for number in ideal_left_numbers if number not in last_line_left_numbers]
                # self.df_errors = self.df_errors._append({'Category': 'PROPOSE', 'Sub-category': 'INCORRECT(E7)', 'Left': second_to_last_line, 'last_line': last_line, 'Reason': f'Numbers {incorrect_numbers} are incorrect in the last line, expected {expected_numbers}'}, ignore_index=True)
                last_line_correct = last_line.replace('left: ' + current_numbers, 'left: ' + ' '.join(map(str, ideal_left_numbers))) # replace the incorrect left numbers with the correct ones

        return last_line_correct